; Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
; This code is licensed under NYSL ver. 0.9982.
; See LICENSE.txt for details.

#module "pcbmodule"

#deffunc dpeek val,val,int
	mref p1,16
	mref p2,25
	mref p3,2
	wpeek p1,p2,cnt
	wpeek a,p2,cnt+2
	p1=a<<16|p1
	return

#deffunc setbufsize int
	mref p1,0
	bufsize=p1
	return

#deffunc settabstops int,int
	mref p1,0
	mref p2,1

	a=4*p2
	objsend p1,$cb,1,a,0
	return

#deffunc tab2space val
	mref stt,64
	mref p1,24

	sdim s,bufsize+1

	strlen len,p1
	repeat len
		ss="_"
		strmid ss,p1,cnt,1
		if ss="\t" {
			repeat
				s+=" "
				strlen a,s
				if a\8=0:break
			loop
		}
		else {
			s+=ss
		}
	loop
	p1=s
	return

#deffunc valcheck val
	mref stt,64
	mref p1,24

	strlen len,p1
	stt=0
	repeat len
		peek a,p1,cnt
		if (a<'0')|(a>'9') : stt=1 : break
	loop
	return

#deffunc delcrlf val,val
	mref stt,64
	mref p1,24
	mref p2,25

	sdim s,bufsize+1
	strlen len,p2
	c=0
	repeat len
		peek a,p2,cnt
		if (a=$0D)|(a=$0A):continue
		poke s,c,a
		c++
	loop
	poke s,c,0
	p1=s
	stt=0
	return

#deffunc getlines val,val
	mref stt,64
	mref p1,16
	mref p2,25

	c=0
	n=0
	repeat
		instr a,p2,"\n",c
		if a<0:break
		c+=a+2
		n++
	loop
	p1=n
	stt=0
	return

#deffunc delspace val,val
	mref stt,64
	mref p1,24
	mref p2,25

	sdim s,bufsize+1
	s=p2
	strlen len,p2
	repeat len
		peek a,p2,cnt
		if (a=$20)|(a=$09):continue
		getstr s,p2,cnt
		break
	loop
	strlen len,s
	if len {
		repeat len
			peek a,s,len-1-cnt
			if (a!$20)&(a!$09):break
			poke s,len-1-cnt,0
		loop
	}
	p1=s
	stt=0
	return

#deffunc getlastname val,val
	mref stt,64
	mref p1,24
	mref p2,25

	sdim s,bufsize+1
	sdim ss,bufsize+1
	sdim sss,bufsize+1
	strlen len,p2
	peek a,p2,len-1
	if a=$5C:p1="":stt=0:return
	next=0
	repeat
		getstr s,p2,next,$5C
		next+=strsize
		if next>=len:break
	loop
	p1=s
	stt=0
	return

#deffunc _getpath val,val
	mref stt,64
	mref p1,24
	mref p2,25

	sdim s,bufsize+1
	s=p2
	strlen len,s
	repeat len,1
		peek a,s,len-cnt
		poke s,len-cnt,0
		if a=$5C:break
	loop
	p1=s
	stt=0
	return

#deffunc delexp val,val
	mref stt,64
	mref p1,24
	mref p2,25

	sdim s,bufsize+1
	s=p2
	strlen len,s
	sw=1
	repeat len,1
		peek a,s,len-cnt
		poke s,len-cnt,0
		if a=$5C:break
		if a='.':sw=0:break
	loop
	if sw:p1=p2:else:p1=s
	stt=0
	return

#deffunc jstr int
	mref js,0
	mref stt,64
	if ((js>=129)&(js<=159))|((js>=224)&(js<=252)) : stt=1 : return
	stt=0
	return

#deffunc lowercase val,val
	mref stt,64
	mref p1,24
	mref p2,25

	strlen len,p2
	repeat len
		peek a,p2,cnt
		if cnt {
			peek b,p2,cnt-1
			jstr b
			if stat {
				poke p1,cnt,a
			}
			else {
				if (a>='A')&(a<='Z'):a+=32
				poke p1,cnt,a
			}
		}
		else {
			if (a>='A')&(a<='Z'):a+=32
			poke p1,cnt,a
		}
	loop
	poke p1,len,0
	stt=0
	return

#deffunc uppercase val,val
	mref stt,64
	mref p1,24
	mref p2,25

	strlen len,p2
	repeat len
		peek a,p2,cnt
		if cnt {
			peek b,p2,cnt-1
			jstr b
			if stat {
				poke p1,cnt,a
			}
			else {
				if (a>='a')&(a<='z'):a-=32
				poke p1,cnt,a
			}
		}
		else {
			if (a>='a')&(a<='z'):a-=32
			poke p1,cnt,a
		}
	loop
	poke p1,len,0
	stt=0
	return

#deffunc valtype val,int
	mref stt,64
	mref pval,1024
	mref type,1

	if type:pval.0=2:else:pval.0=4
	stt=0
	return

#deffunc chgstyle int
	mref stt,64
	mref p1,0
	mref bmscr,67

	bmscr.17 = p1
	stt=0
	return

#deffunc btnstyle int,int
	mref stt,64
	mref p1,0
	mref p2,1

	a=-1
	objsend p1,$f4,p2,a,1
	stt=0
	return

#deffunc dehex val,val
	mref stt,64
	mref p1,16
	mref p2,25

	sdim s,bufsize+1
	s=p2
	p1=0

	strlen len,s
	if len=0:return
	repeat len
		peek a,s,cnt
		if (a>='a')&(a<='f'):a-=$20
		poke s,cnt,a
	loop

	a=1
	if len>1:repeat len-1:a=a*16:loop
	repeat len
		peek b,s,cnt
		if (b>='0')&(b<='9') : b-='0' : else : b-='A'-10
		p1=b*a|p1
		a=a/16
	loop
	stt=0
	return

#deffunc mousearea int,int,int,int,int,int
	mref stt,64
	mref p1,0
	mref p2,1
	mref p3,2
	mref p4,3
	mref p5,4
	mref p6,5

	if (p3<=p1)&(p1<=p5)&(p4<=p2)&(p2<=p6) : stt=1 : return

	stt=0
	return

#deffunc groupbox str,int,int
	mref p1,32
	mref p2,1
	mref p3,2
	x=csrx:y=csry
	dmy=""
	objsize p2,p3
	mesbox dmy,,,2
	a=stat
	pos x,y
	button "",*nop
	b=0
	objsend a+1,$f4,7,b,1
	objprm a+1,p1
	objsel a+1
	return
	*nop:stop

#deffunc radio int
	mref p1,0
	a=-1:objsend p1,$f4,9,a,1
	return

#global
	setbufsize 4096
